#include <stdio.h>
#include <stdlib.h>
#include <vgagl.h>
#include <vga.h>
#include <math.h>
#include "gamesup.h"

extern angletable sinus,cosin;

/* 
 *    fast mathematical functions 
 */

extern void init_fast_angle_functions(void)  {
int i;
	for (i=0; i<=3599; i++)  {
	  sinus[i] = sin( i*pi/1800 );
	  cosin[i] = cos( i*pi/1800 );
	}
}

/*
 *    graphic support 
 */

extern void load_tga(char *name,int pic_xoff,int pic_yoff,int pic_xres,int pic_yres)  {
FILE *file_p;
unsigned char red,green,blue;
int errc,x,y;

	printf("\ntrying to load %s...",name);
	file_p = fopen(name,"r");
	fseek(file_p,18,SEEK_SET);

	for (y=0; y<pic_yres; y++)
          for (x=0; x<pic_xres; x++)  {
        
            if ((feof(file_p)) || (errc=ferror(file_p)!=0)) break;
		fread(&blue,sizeof(char),1,file_p);
		fread(&green,sizeof(char),1,file_p);
		fread(&red,sizeof(char),1,file_p);
	     gl_setpixelrgb(pic_xoff+x,pic_yoff+y,(int)red,(int)green,(int)blue);
	  }
	fclose(file_p);
	if (errc==0) printf("success");
	else printf("error %d occured",errc);
}
                                                                                                                            
    
extern void fadescreen(void)  {
	gl_clearscreen(gl_rgbcolor(0,0,0));
}


extern void draw_mousecursor(int x,int y)  {	
	gl_line(x-8,y,x+8,y,gl_rgbcolor(255,255,255));
	gl_line(x,y-8,x,y+8,gl_rgbcolor(255,255,255));
	gl_circle(x,y,1,gl_rgbcolor(0,0,0));
	gl_circle(x,y,2,gl_rgbcolor(255,255,255));
	gl_circle(x,y,3,gl_rgbcolor(0,0,0));
	gl_circle(x,y,4,gl_rgbcolor(255,255,255));
	gl_circle(x,y,5,gl_rgbcolor(0,0,0));
	gl_circle(x,y,6,gl_rgbcolor(255,255,255));
	gl_circle(x,y,7,gl_rgbcolor(0,0,0));
}


extern void init_starfield(mover pix)  {
int a,p;

	for (a=0; a<=starnum; a++)  {
	   pix[a].x = (int)(10+(xres-20)*(double)rand()/RAND_MAX);
	   pix[a].y = 40 + ((int)((yres - 40)*(double)rand()/RAND_MAX));
	   pix[a].vx = (double)rand()/RAND_MAX;
	   p = (int)(128*(double)rand()/RAND_MAX );	
	   pix[a].color = gl_rgbcolor((int)(p+random*20),(int)(p+random*20),(int)(p+random*20));	
	}
}


extern void background_starfield(mover pix,GraphicsContext *gc)  {
int a,bpp;
unsigned char redraw_r,redraw_b,redraw_g;
static float x_old[starnum+1];

	bpp = gc->bytesperpixel;			
	for (a=0; a<=starnum; a++)  {
	  if (pix[a].x<vga_getxdim()-10)  {  	
	      redraw_r = *(gc->vbuf+
	      		  (bpp*((int)pix[a].y*xres+(int)x_old[a])));
	      redraw_g = *(gc->vbuf+sizeof(char)+
	                  (bpp*((int)pix[a].y*xres+(int)x_old[a])));
	      redraw_b = *(gc->vbuf+2*sizeof(char)+
	                  (bpp*((int)pix[a].y*xres+(int)x_old[a])));
	      gl_setpixel(x_old[a],pix[a].y,gl_rgbcolor(redraw_b,redraw_g,redraw_r));
	      gl_setpixel(pix[a].x,pix[a].y,pix[a].color);
	      x_old[a] = pix[a].x;
	      pix[a].x += pix[a].vx;
	  } else pix[a].x = 10;
	}
}


extern void init_sphere(int xb,int yb,spheremover pix)  {
int a;
	for (a=0; a<=sphere_starnum; a++)  {
	   pix[a].rad = 170;
	   pix[a].wx  = xb * 10 * (double)rand()/RAND_MAX;
	   pix[a].wy  = yb * 10 * (double)rand()/RAND_MAX;
	}
}


extern void background_sphere(spheremover pix,GraphicsContext *gc)  {
int a,z,bpp;
unsigned char redraw_r,redraw_b,redraw_g;
static int x,y,x_old[sphere_starnum+1],y_old[sphere_starnum+1];
       
	bpp = gc->bytesperpixel;
	for (a=1; a<=sphere_starnum; a++)  {
     	  redraw_r = *(gc->vbuf+
     	 	      (bpp*(y_old[a]*xres+x_old[a])));
	  redraw_g = *(gc->vbuf+(sizeof(char)+
	  	      (bpp*(y_old[a]*xres+x_old[a]))));
	  redraw_b = *(gc->vbuf+(2*sizeof(char)+
	  	      (bpp*(y_old[a]*xres+x_old[a]))));
	  gl_setpixel(x_old[a],y_old[a],gl_rgbcolor(redraw_b,redraw_g,redraw_r));
              
              pix[a].wx+=3;
              pix[a].wy+=3;
              pix[a].rad = (int)(120+59*sinus[pix[1].wx%3600]);
	    x_old[a]=x;
	    y_old[a]=y;
	    x = xres/2 + pix[a].rad * cosin[pix[a].wx%3600] * sinus[pix[a].wy%3600];
	    y = yres/2 + pix[a].rad * sinus[pix[a].wx%3600] * sinus[pix[a].wy%3600];
	    z =    500 + pix[a].rad * cosin[pix[a].wy%3600];
	  gl_setpixel(x,y,gl_rgbcolor(x/2,y/2,z/2));
	}
}


extern gameball init_gameball(float x, float y,float vx,float vy)  {
gameball _;

	_.x  = x;
	_.y  = y;
	_.vx = vx;
	_.vy = vy;
	return _;
}        


extern gameball ball_movebasic(gameball _)  {

	_.x += _.vx;
	_.y += _.vy;

	if (_.x > xres-10) {_.vx = -fabs(_.vx); _.x=xres-10; }
	if (_.x < 10)      {_.vx =  fabs(_.vx); _.x=10; }
	if (_.y > yres-10) {_.vy = -fabs(_.vy); _.y=yres-10; }
	if (_.y < 10)      {_.vy =  fabs(_.vy); _.y=10; }
	return _;
}


extern gameball ball_moveadvanced(gameball ball,level *acc)  {
static float p;

	p += 0.001;
	ball.vx += sin(p) * acc->ax;
	ball.vy += sin(p) * acc->ay;
	return ball;
}


extern gamepad calcpad(gamepad pad,int maxspeed,gameball ball)  {
float 	hypypos;
int 	move_y;

	hypypos = ball.y - ball.x*ball.vy/ball.vx;
	if (hypypos<0)    hypypos = pad.l;
	if (hypypos>yres) hypypos = yres;

	if (ball.vx<0) {
	   move_y = (int)(0.13*(hypypos-(pad.y + pad.l/2)));
	   if (move_y>maxspeed)       move_y =  maxspeed;
	   else if (move_y<-maxspeed) move_y = -maxspeed;
	   pad.y += move_y;
 	}
	if (pad.y<0) pad.y=0;
	if (pad.y>yres-pad.l) pad.y=yres-pad.l;
	
	return pad;
}


extern level *load_levelmap(char *name)  {
FILE *file_p;
level *start;

	start = malloc(640*480*sizeof(level));
	if (start == NULL)  { 
	  printf("\nmemory allocation for levelmap1 failed");
	  exit(0);
	} else printf("\nmemory allocation for levelmap succesfull...");
	  
	file_p=fopen(name,"r");
	  fread(start,sizeof(level),640*480,file_p);
	fclose(file_p);
	return start;
}                                         


extern void calc_situation(gamepad *comp,gamepad *player,gameball *ball)  {

const int y_upperborder = 50;

	ball->x += ball->vx;
	ball->y += ball->vy;

	if (ball->y > yres-20) { ball->vy = -0.9*fabs(ball->vy); ball->y = yres-20; }
	if (ball->y < y_upperborder) { ball->vy = 0.9*fabs(ball->vy); ball->y = y_upperborder; }
	if ( (ball->x > (xres-40)) && 
	     (ball->y > player->y) && 
	     (ball->y < (player->y + player->l)) )  {
		ball->vx = -1.04*fabs(ball->vx);
		ball->vy = (ball->y - player->y - player->l/2)/4;
	}  else if (ball->x > xres - 20) {
		ball->x  = xres-10;
		ball->y  = 100;
		ball->vx = -6;
		ball->vy = 0;
		player->points++;
	}
	if ( (ball->x < 40) && 
	     (ball->y > comp->y) && 
	     (ball->y < (comp->y+comp->l)) )  {
		ball->vx = 1.04*fabs(ball->vx);
		ball->vy = (ball->y - comp->y - comp->l/2)/4;
	}  else if (ball->x < 20) {
  		ball->x  = 10;
		ball->y  = yres-100;
		ball->vx = 6;
		ball->vy = 0;
                comp->points++;
	}                 
}     