#include <stdio.h>
#include <stdlib.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <vgakeyboard.h>
#include <time.h>
#include "gamesup.h"

#define xres vga_getxdim()
#define yres vga_getydim()
#define rand_num (double)rand()/RAND_MAX 
#define sqr(x) ((x)*(x)) 

GraphicsContext *physicalscreen,*virtualscreen;

/* 
 *  function prototype's 
 */

void init_graph(int);
void init_inputdevices(void);
void bailout(void);
void play_game(int);
void manager();

/*
 *  function implementation
 */

void init_graph(sm)  {
        vga_init();
//      vga_setchipset(CIRRUS);
        
        if ( vga_hasmode(sm) == 0 )  {
          printf("\nThis program needs a true color 640x480 resolution to run properly.");
          printf("\nvga_init() was'nt able to detect this mode for your grafik hardware.");
            if (vga_getcurrentchipset() == VGA)  
            printf("\n(to be exact : vga_init() was'nt able to detect your grafik card correctly)");
          printf("\n\nOn how to possibly fix this problem see the README file\n\n");
          exit(0);
        }  else printf("\n640x480 true color mode detected.");  

        vga_setmode(sm);

        virtualscreen = gl_allocatecontext();
          gl_setcontextvgavirtual(sm);
          gl_getcontext(virtualscreen);
          gl_setcontextvga(sm);
        physicalscreen = gl_allocatecontext();
          gl_getcontext(physicalscreen);
	  gl_setcontext(virtualscreen);
}


void init_inputdevices(void)  {
	keyboard_init();
	mouse_init("/dev/mouse",MOUSE_MICROSOFT,MOUSE_DEFAULTSAMPLERATE);
	mouse_setposition(100,250);
	mouse_setwrap(MOUSE_NOWRAP);
	mouse_setxrange(15,xres-15);
	mouse_setyrange(15,yres-15);
}


void bailout(void)  {
	gl_freecontext(virtualscreen);
	gl_freecontext(physicalscreen);
	   mouse_close();
	   keyboard_close();
	   vga_setmode(TEXT);
	printf("\n\narcade tennis V0.83_beta_c (c) 199(7+x) closed");
	printf("\nFor more infomation please contact me at : inberg@student.tu-freiberg.de\n\n");
	exit(0);
}


void play_game(int game_state)  {
mover stars;
spheremover sphere_stars;
gameball ball,oldball; 
gamepad pad[2],oldpad[2];
int k=0;
level *level_p;
void *ball_buf,*ball_redrawbuf,*pad1_buf,*pad2_buf;
void *screen_redrawbuf,*number_buf;
double dt,rng,acc;
time_t st,et;

    mouse_setyrange(40,yres-73);
    init_fast_angle_functions();
    init_starfield(stars);
    init_sphere(90,360,sphere_stars);

/* Level 1 */

     gl_clearscreen(gl_rgbcolor(0,0,0));
  load_tga("./levels/level1.tga",0,0,640,480);
     	level_p = load_levelmap("./levels/level1.map");
     
     gl_setcontext(virtualscreen);	
	pad[1].l = pad[2].l = 73;
  load_tga("./buttons/pad1.tga",0,0,27,pad[1].l);
  load_tga("./buttons/pad2.tga",40,0,27,pad[2].l);
  load_tga("./buttons/ball.tga",100,100,20,20);
  load_tga("./buttons/numbers.tga",0,200,400,40);
	pad1_buf = malloc(27*73*BYTESPERPIXEL);  
	pad2_buf = malloc(27*73*BYTESPERPIXEL);  
	ball_buf = malloc(20*20*BYTESPERPIXEL);  
	number_buf = malloc(400*40*BYTESPERPIXEL);   
		gl_getbox(0,0,27,73,pad1_buf);
		gl_getbox(40,0,27,73,pad2_buf);
		gl_getbox(100,100,20,20,ball_buf);	
     		gl_getbox(0,200,400,40,number_buf);
     	
	load_tga("./levels/background2.tga",0,0,640,480);
	screen_redrawbuf = malloc(xres*yres*BYTESPERPIXEL);  
		gl_getbox(0,0,xres,yres,screen_redrawbuf);
  load_tga("./levels/level1_title.tga",80,0,480,40);
	
     gl_copyscreen(physicalscreen);	 
     gl_setcontext(physicalscreen);
     
     ball = init_gameball(120,100,3,1); 	
     
     time(&st);
     while ( (pad[1].points!=11) && (pad[2].points!=11) )  {
	k++;
	background_starfield(stars,virtualscreen);    
	background_sphere(sphere_stars,virtualscreen);

/*  point status */

	if ( (pad[1].points != oldpad[1].points) || 
	     (pad[2].points != oldpad[2].points) )  {
	  gl_putboxpart(xres-80,0,41,40,400,40,number_buf,(pad[1].points%11)*35,0);
	  gl_putboxpart(40     ,0,41,40,400,40,number_buf,(pad[2].points%11)*35,0);
	}

/* ball redrawing  */
	
	gl_putboxpart(
	   (int)ball.x-10,(int)ball.y-10,20,20,xres,yres,screen_redrawbuf,
	   (int)ball.x-10,(int)ball.y-10);

/*  ball & pad movement's  */

		rng = sqrt(sqr(xres/2 - ball.x)+sqr(yres/2 - ball.y));
		acc = 7/rng;
		ball.vx += acc/rng*(xres/2 - ball.x);
	        ball.vy += acc/rng*(yres/2 - ball.y);
	        ball.vx *=1.0001;
	        ball.vy *=1.0001;
	        ball.x += ball.vx;
		ball.y += ball.vy;

//	   ball = ball_moveadvanced(ball,level_p+(int)(ball.x*480+ball.y));
	     oldpad[1] = pad[1];
	     oldpad[2] = pad[2];
	   calc_situation(&pad[1],&pad[2],&ball);

/*  Game Controls  */

	keyboard_update();	
	if (keyboard_keypressed(SCANCODE_ESCAPE)) bailout();

	if ( (game_state == __1player) || (game_state == __2player) )  {  
	   mouse_update();
	   pad[2].y = mouse_gety();
	} 
	if (game_state == __2player)  {
//	   keyboard_update();
	   if ((keyboard_keypressed(SCANCODE_CURSORUP)) && (pad[1].y>40))   
	     pad[1].y -= 13;
	   if ((keyboard_keypressed(SCANCODE_CURSORDOWN)) && (pad[1].y<(yres-pad[2].l-13)))
	     pad[1].y += 13;
	} else pad[1] = calcpad(pad[1],10,ball);		           
	if (game_state == __0player) 
	  pad[2].y = (int)(pad[2].y+0.3*(ball.y-(pad[2].y+pad[2].l/2)));
	   
	   if (pad[2].y<40) pad[2].y=40;
	   if (pad[2].y>yres-pad[1].l) pad[2].y = yres-pad[1].l;

/*  grafik drawing */	

/* ball */ gl_putboxmask((int)ball.x-10,(int)ball.y-10,20,20,ball_buf);
	   vga_waitretrace();
/* pad1	*/ gl_putbox(0,pad[1].y,27,73,pad1_buf);
	   gl_putboxpart(0,0,27,pad[1].y,xres,yres,screen_redrawbuf,0,0);
	   gl_putboxpart(0,pad[1].y+pad[1].l,27,yres-pad[1].y-pad[1].l,xres,yres,screen_redrawbuf,
	   		 0,pad[1].y+pad[1].l);
/* pad2 */ gl_putbox(xres-27,pad[2].y,27,73,pad2_buf);
	   gl_putboxpart(
	   	xres-27,0,27,pad[2].y,xres,yres,screen_redrawbuf,
		xres-27,0);
	   gl_putboxpart(
	     	xres-27,pad[2].y+pad[2].l,27,yres-pad[2].y-pad[2].l,xres,yres,screen_redrawbuf,
		xres-27,pad[2].y+pad[2].l);
     }
     time(&et);
 
     dt=difftime(et,st);
     printf("\nFramezahl :  %3.2f  Frames/sek.\n",k/dt);	
       if (pad[2].points == 11) load_tga("./levels/comp_won.tga",160,200,320,80);
       if (pad[1].points == 11) load_tga("./levels/ply_won.tga",160,200,320,80);
	pad[1].points = pad[2].points = 0;
     while ( difftime(st,et)<4 ) time(&st);

     free(level_p);
     free(screen_redrawbuf);
     free(pad1_buf);  
     free(pad2_buf);  
     free(ball_buf);  
     free(number_buf);   
//   play_game(game_state);
     manager();
}


void manager()  {
typedef struct  {
	void *pressed_p,*normal_p;	
  	int x,y,w,h;
} gui_button;

gui_button button[5];
int button_set=1,x,y,mouse_x,mouse_y;
void *redrawbuf_p;
char *buttonstate_p;

	gl_setcontext(virtualscreen);
	if ((redrawbuf_p = malloc(30*30*BYTESPERPIXEL)) == NULL)  {
	     printf("\nmemory allocation error while trying to allocate mouse pointer redraw buffer...");
 	     exit(0);
	} else printf("\nmemory allocation for mouse pointer redraw succesfull...");
		
/*  create introscreen / load normal button images  */

	for (x=1; x<=4; x++)  {  
	  button[x].x = 210;
	  button[x].y = 120+80*(x-1);
	  button[x].w = 220;
	  button[x].h = 50;
      	}
      	
  load_tga("./buttons/title_3.tga",0,0,640,480);
  load_tga("./buttons/button1.tga",button[1].x,button[1].y,button[1].w,button[1].h);
  load_tga("./buttons/button2.tga",button[2].x,button[2].y,button[2].w,button[2].h);
  load_tga("./buttons/button3.tga",button[3].x,button[3].y,button[3].w,button[3].h);
  load_tga("./buttons/button4.tga",button[4].x,button[4].y,button[4].w,button[4].h);
	gl_copyscreen(physicalscreen);
	
	for (x=1; x<=4; x++)  {
  	    if ((button[x].normal_p = malloc(220*50*BYTESPERPIXEL)) == 0)  {
	       printf("\nmemory allocation failure while trying to load button %d image...\n",x);
	       exit(0);
 	    } else printf("\nmemory allocation for button %d image succesfull...",x);
	  gl_getbox(button[x].x,button[x].y,
	            button[x].w,button[x].h,
	            button[x].normal_p);
        }
 	 			
/*  load pressed button images in virtual screen  */

  load_tga("./buttons/button1_pressed.tga",button[1].x,button[1].y,button[1].w,button[1].h);
  load_tga("./buttons/button2_pressed.tga",button[2].x,button[2].y,button[2].w,button[2].h);
  load_tga("./buttons/button3_pressed.tga",button[3].x,button[3].y,button[3].w,button[3].h);
  load_tga("./buttons/button4_pressed.tga",button[4].x,button[4].y,button[4].w,button[4].h);	

	for (x=1; x<=4; x++)   {
	  if ((button[x].pressed_p = malloc(220*50*BYTESPERPIXEL)) == NULL)  {
	    printf("\nmemory allocation failure while trying to load pressed button %d image...\n",x);
	    exit(0);
	  } else printf("\nmemory allocation for pressed button %d image succesfull...",x);
	  gl_getbox(button[x].x,button[x].y,button[x].w,button[x].h,
	            button[x].pressed_p);
        }
	gl_setcontext(physicalscreen);
	 
/* create button_map */

        if ((buttonstate_p = malloc(xres*yres*BYTESPERPIXEL)) == NULL)  {
         	printf("\nmemory allocation failure while trying to build buttonmap...");
         	exit(0);
        } else printf ("\nmemory allocation for buttonmap succesfull...");
        	 
	for (x=0; x<xres; x++)
	  for (y=0; y<yres; y++)  {
	    if ((x>210) && (x<430) && (y>120) && (y<170)) *(buttonstate_p+(yres*x+y)) = 1;
       else if ((x>210) && (x<430) && (y>200) && (y<250)) *(buttonstate_p+(yres*x+y)) = 2;
       else if ((x>210) && (x<430) && (y>280) && (y<330)) *(buttonstate_p+(yres*x+y)) = 3;
       else if ((x>210) && (x<430) && (y>360) && (y<410)) *(buttonstate_p+(yres*x+y)) = 4;
       else *(buttonstate_p+(yres*x+y)) = 0;
 	  }
 
/* main loop */

  for (;;)  {
	gl_getbox(mouse_x-10,mouse_y-10,20,20,redrawbuf_p);
 	draw_mousecursor(mouse_x,mouse_y);
	  mouse_waitforupdate();
  	gl_putbox(mouse_x-10,mouse_y-10,20,20,redrawbuf_p);
	  mouse_x = mouse_getx();
	  mouse_y = mouse_gety();
   
/* check whether mouseposition is buttonposition and draw mousepointer */
		
	if ( ( *(buttonstate_p + (mouse_x*yres + mouse_y) )!=0) &&
	     ( *(buttonstate_p + (mouse_x*yres + mouse_y) )!=button_set) )  {  
	  gl_putbox(210,button[button_set].y,button[button_set].w,
	                button[button_set].h,button[button_set].normal_p); 
  	    button_set = *(buttonstate_p + ( mouse_x*yres+mouse_y ));  
   	  gl_putbox(210,button[button_set].y,button[button_set].w,
   	                button[button_set].h,button[button_set].pressed_p); 
        }

	if (mouse_getbutton() & MOUSE_LEFTBUTTON)
 	  switch (button_set)  {
		  case 1 : {	free(redrawbuf_p); 
				for (x=1; x<=4; x++)  {
				    free(button[x].pressed_p);
				    free(button[x].normal_p);  }
			        play_game(__1player);
			   }			    
		  case 2 : {	free(redrawbuf_p); 
				for (x=1; x<=4; x++)  {
				  free(button[x].pressed_p);
				  free(button[x].normal_p);  }
			        play_game(__2player);
			   }			    
		  case 3 : {	free(redrawbuf_p); 
				for (x=1; x<=4; x++)  {
				  free(button[x].pressed_p);
				  free(button[x].normal_p);  }
			        play_game(__0player);
			   }			    
		  case 4 : {	free(redrawbuf_p); 
				for (x=1; x<=4; x++)  {
				  free(button[x].pressed_p);
				  free(button[x].normal_p);  }
			        bailout();
			   }      
	  }	      
  }
}


void main(int argc,char **argv)  {
	init_graph(G640x480x16M);
	init_inputdevices();
        manager();
}
